#!/usr/bin/env python3
import json
import sys


def get_numbers(data):
    if isinstance(data, int):
        yield data
    elif isinstance(data, dict):
        if 'red' in data.keys() or 'red' in data.values():
            return
        for value in data.values():
            yield from get_numbers(value)
    elif isinstance(data, list):
        for item in data:
            yield from get_numbers(item)


print(sum(get_numbers(json.load(sys.stdin))))
